unit Unit14;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ExtCtrls, Vcl.ExtDlgs,jpeg,Clipbrd,
  Vcl.StdCtrls;

type
  TForm14 = class(TForm)
    Image1: TImage;
    SavePictureDialog1: TSavePictureDialog;
    Panel1: TPanel;
    Label1: TLabel;
    Panel2: TPanel;
    Label2: TLabel;
    Panel3: TPanel;

    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Image1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private 錾 }
    function MIN(X,Y:Integer):Integer;
    function MAX(X,Y:Integer):Integer;
  procedure HCOPY(Sender:TObject);
  public
    { Public 錾 }
  end;

var
  Form14: TForm14;
  FDrag  :boolean; //}EXhbOtO
  DownPt :TPoint;  //``̊_ƂȂ}EX낳ꂽW
  R      :TRect;   //݂̑I`

implementation

{$R *.dfm}

uses Unit1, Unit16;

function TForm14.MIN(X,Y:Integer):Integer;
var
Z:integer;
begin
if X > Y then
begin
 Z:=Y;
end else
begin
 Z:=X;
end;
result:=Z;
end;

function TForm14.MAX(X,Y:Integer):Integer;
var
Z:integer;
begin
if X > Y then
begin
 Z:=X;
end else
begin
 Z:=Y;
end;
result:=Z;
end;

procedure TForm14.Image1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
   if Button =mbRight then  ModalResult:=mrOK;
   //Ő`
   Image1.Canvas.DrawFocusRect(R);
   DownPt :=Point(X, Y);
   FDrag :=true;
   R :=Rect(X, Y, X, Y);
   Image1.Canvas.DrawFocusRect(R);

end;

procedure TForm14.Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
   if FDrag then begin
   //Ő`
   Image1.Canvas.DrawFocusRect(R);

   //݂̃}EXʒuƊ_̍WVȋ`Zbg
   R :=Rect(MIN(Downpt.X, X), MIN(Downpt.Y, Y),
            MAX(Downpt.X, X), MAX(Downpt.Y, Y));
   Panel2.Caption:=IntToStr(R.Right-R.Left);
   Panel3.Caption:=IntToStr(R.Bottom-R.Top);
   if (R.Right-R.Left) div 16 = (R.Bottom-R.Top) div 9 then
   begin
   Panel1.Color:=clBlue;
   beep;
   end else
   begin
   Panel1.Color:=clRed;

   end;

   //VȍWŋ``
   Image1.Canvas.DrawFocusRect(R);
  end;

end;

procedure TForm14.Image1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
   //hbOIŃtO False
  FDrag :=false;
  Image1.Canvas.DrawFocusRect(R);
  //ۑ
  HCOPY(Sender);

  //Image1.Picture.Graphic:=nil;
  R :=Rect(0, 0,0, 0);
 ModalResult:=mrOK;
end;

//Lv`[ĕۑ
procedure TForm14.FormClose(Sender: TObject; var Action: TCloseAction);
begin
// Form1.Top:=0;
//Form1.Left:=0;
//Form1.ClientWidth:=NOWX;//ZETTAIX;//:=1366;
//Form1.ClientHeight:=NOWY;//ZETTAIY;//:=768;
//Form1.WindowState := wsMaximized;
// Form1.BringToFront;
 Form16.BringToFront;
 Form16.Top:=6;
 Form16.Left:=6;
end;

procedure TForm14.FormCreate(Sender: TObject);
begin
// Form14.FormState:=fsStayOnTop;
end;

procedure TForm14.FormShow(Sender: TObject);
begin
 //őOʂɕ\
//messageBeep(MB_ICONEXCLAMATION);
MessageBeep(MB_ICONASTERISK);
Panel1.Color:=clRed;

SetWindowPos(Self.Handle,HWND_TOPMOST,0,0,0,0,SWP_NOSIZE or SWP_NOMOVE);
//GetforegroundWindow;

//ʂɖ߂
//SetWindowPos(Handle,HWND_NOTOPMOST,0,0,0,0,SWP_NOSIZE or SWP_NOMOVE);

//Form14.BringToFront;
 // BringWindowtotop(Form14.Handle);
 // Form14.SetFocus;

//  OnDeactivate(Form14);
end;

procedure TForm14.HCOPY(Sender:TObject);
var
 NBMP: TBitmap;
 Dest,Src: TRect;
 JPG:TJpegImage;
 F,KAKU:String;
begin
  NBMP := TBitmap.Create;
   try
   NBMP.Width :=R.Right-R.Left;
   NBMP.Height :=R.Bottom - R.Top;
   NBMP.PixelFormat := pf24bit;

   Dest:=Rect(0,0,NBMP.Width,NBMP.Height);
   Src :=R;
   NBMP.Canvas.CopyRect(Dest,Image1.Canvas,Src);


//--------------------------------------

 Clipboard.Assign(NBMP);
 Form14.WindowState:=wsMinimized;
if (NBMP.Width>0) and  (NBMP.Height>0) then
begin
Form1.OTO2;
  if SavePictureDialog1.Execute then
  begin
  F:=SavePictureDialog1.FileName;
  KAKU:=AnsiLowerCase(ExtractFileExt(F));
  //-----bmp-----
    if KAKU='.bmp' then
    begin
     try
     NBMP.SaveToFile(F);
     except
     end;
    end;
    if (KAKU='.jpg')or(KAKU='.jpeg') then
    begin
      JPG := TJpegImage.Create;
      try
      JPG.CompressionQuality:=100;
      JPG.Assign( NBMP );
      JPG.Compress;
      JPG.SaveToFile(F);
      finally
      JPG.Free;
      end;

    end;
  // Form1.KABECHK('');

  end;
end;

   finally
     NBMP.Free;
   end;




end;

end.
