unit Unit17;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.Buttons, Vcl.OleCtrls,
  SHDocVw, Vcl.ExtCtrls, Vcl.ComCtrls;

type
  TForm17 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    WebBrowser1: TWebBrowser;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    StatusBar1: TStatusBar;
    Edit2: TEdit;
    Panel3: TPanel;
    Edit1: TEdit;
    SpeedButton5: TSpeedButton;
    SpeedButton6: TSpeedButton;
    SpeedButton4: TSpeedButton;
    SpeedButton7: TSpeedButton;
    procedure FormShow(Sender: TObject);
    procedure WebBrowser1CommandStateChange(ASender: TObject; Command: Integer;
      Enable: WordBool);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure SpeedButton6Click(Sender: TObject);
    procedure SpeedButton5Click(Sender: TObject);
    procedure WebBrowser1NavigateComplete2(ASender: TObject;
      const pDisp: IDispatch; const URL: OleVariant);
    procedure WebBrowser1TitleChange(ASender: TObject; const Text: WideString);
    procedure WebBrowser1StatusTextChange(ASender: TObject;
      const Text: WideString);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton7Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form17: TForm17;

implementation

{$R *.dfm}

procedure TForm17.FormShow(Sender: TObject);
begin
WebBrowser1.Navigate(Edit1.Text);
end;

procedure TForm17.SpeedButton1Click(Sender: TObject);
begin
  WebBrowser1.GoBack;
end;

procedure TForm17.SpeedButton2Click(Sender: TObject);
begin
  WebBrowser1.GoForward;
end;
//---HOME-----
procedure TForm17.SpeedButton3Click(Sender: TObject);
begin
  WebBrowser1.Navigate(Edit2.Text);
end;

procedure TForm17.SpeedButton4Click(Sender: TObject);
begin
 if WebBrowser1.Document<>nil then
 begin
   WebBRowser1.Refresh;
 end;
end;

procedure TForm17.SpeedButton5Click(Sender: TObject);
begin
  if WebBrowser1.Busy=True then
  begin
    WebBrowser1.Stop;
  end;
end;

procedure TForm17.SpeedButton6Click(Sender: TObject);
begin
  if Edit1.Text='' then
  begin
    Edit1.Text:='about:blank';
  end;
  WebBrowser1.Navigate(Edit1.Text);
end;

procedure TForm17.SpeedButton7Click(Sender: TObject);
var
  d:olevariant;
begin
  WebBrowser1.ExecWB(OLECMDID_PRINTPREVIEW,OLECMDEXECOPT_DODEFAULT, d,d);
end;

procedure TForm17.WebBrowser1CommandStateChange(ASender: TObject;
  Command: Integer; Enable: WordBool);
begin
 case Command of
 CSC_NAVIGATEFORWARD:
 begin
   SpeedButton2.Enabled:=Enable;
 end;
 CSC_NAVIGATEBACK:
 begin
   SpeedButton1.Enabled:=Enable;
 end;
 end;
end;

procedure TForm17.WebBrowser1NavigateComplete2(ASender: TObject;
  const pDisp: IDispatch; const URL: OleVariant);
begin
   Edit1.Text:=WebBrowser1.LocationURL;
end;

procedure TForm17.WebBrowser1StatusTextChange(ASender: TObject;
  const Text: WideString);
begin
  StatusBar1.SimpleText:=Text;
end;

procedure TForm17.WebBrowser1TitleChange(ASender: TObject;
  const Text: WideString);
begin
  Self.Caption:=Text;
end;

end.
